VERSION 5.00
Begin VB.Form frmMemory 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Speicheranzeige"
   ClientHeight    =   2280
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   Icon            =   "Memory.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2280
   ScaleWidth      =   4680
   StartUpPosition =   1  'Fenstermitte
   Begin VB.CommandButton cmdByte 
      Caption         =   "Byte"
      Height          =   300
      Left            =   2190
      TabIndex        =   12
      Top             =   1944
      Width           =   570
   End
   Begin VB.Label Label9 
      Caption         =   "Label9"
      Height          =   216
      Left            =   180
      TabIndex        =   11
      Top             =   1692
      Width           =   2568
   End
   Begin VB.Label Label10 
      Alignment       =   1  'Rechts
      Caption         =   "Label10"
      Height          =   216
      Left            =   2988
      TabIndex        =   10
      Top             =   1692
      Width           =   1500
   End
   Begin VB.Label Label11 
      Caption         =   "Label11"
      Height          =   216
      Left            =   180
      TabIndex        =   9
      Top             =   1908
      Width           =   2568
   End
   Begin VB.Label Label12 
      Alignment       =   1  'Rechts
      Caption         =   "Label12"
      Height          =   216
      Left            =   2988
      TabIndex        =   8
      Top             =   1908
      Width           =   1500
   End
   Begin VB.Label Label8 
      Alignment       =   1  'Rechts
      Caption         =   "Label8"
      Height          =   216
      Left            =   2988
      TabIndex        =   7
      Top             =   1188
      Width           =   1500
   End
   Begin VB.Label Label7 
      Caption         =   "Label7"
      Height          =   216
      Left            =   180
      TabIndex        =   6
      Top             =   1188
      Width           =   2568
   End
   Begin VB.Label Label6 
      Alignment       =   1  'Rechts
      Caption         =   "Label6"
      Height          =   216
      Left            =   2988
      TabIndex        =   5
      Top             =   972
      Width           =   1500
   End
   Begin VB.Label Label5 
      Caption         =   "Label5"
      Height          =   216
      Left            =   180
      TabIndex        =   4
      Top             =   972
      Width           =   2568
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Rechts
      Caption         =   "Label4"
      Height          =   216
      Left            =   2988
      TabIndex        =   3
      Top             =   472
      Width           =   1500
   End
   Begin VB.Label Label3 
      Caption         =   "Label3"
      Height          =   216
      Left            =   180
      TabIndex        =   2
      Top             =   472
      Width           =   2568
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Rechts
      Caption         =   "Label2"
      Height          =   220
      Left            =   2988
      TabIndex        =   1
      Top             =   252
      Width           =   1500
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   220
      Left            =   180
      TabIndex        =   0
      Top             =   252
      Width           =   2568
   End
End
Attribute VB_Name = "frmMemory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type MEMORYSTATUS
  dwLength As Long                ' Gesamtlnge der Struktur
  dwMemoryLoad As Long     ' Prozent des belegten Speichers
  dwTotalPhys As Long           ' Gesamtarbeitsspeicher
  dwAvailPhys As Long           ' Verfgbarer Arbeitsspeicher
  dwTotalPageFile As Long    ' Gre der Auslagerungsdatei
  dwAvailPageFile As Long    ' davon noch frei
  dwTotalVirtual As Long         ' Gre d. virtuellen Speichers
  dwAvailVirtual As Long         ' Verfgbarer virtueller Speicher
End Type

Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Private Sub cmdByte_Click()
  Dim lngByte As Long
  
  If cmdByte.Caption = "Byte" Then
    lngByte = Val(Label2.Caption)
    Label2.Caption = lngByte \ 1024
    lngByte = Val(Label4.Caption)
    Label4.Caption = lngByte \ 1024
    Label5.Caption = "Kilobytes in gepageten Dateien : "
    lngByte = Val(Label6.Caption)
    Label6.Caption = lngByte \ 1024
    lngByte = Val(Label8.Caption)
    Label8.Caption = lngByte \ 1024
    lngByte = Val(Label10.Caption)
    Label10.Caption = lngByte \ 1024
    lngByte = Val(Label12.Caption)
    Label12.Caption = lngByte \ 1024
    cmdByte.Caption = "KB"
  Else
    lngByte = Val(Label2.Caption)
    Label2.Caption = lngByte * 1024
    lngByte = Val(Label4.Caption)
    Label4.Caption = lngByte * 1024
    Label5.Caption = "Bytes in gepageten Dateien :  "
    lngByte = Val(Label6.Caption)
    Label6.Caption = lngByte * 1024
    lngByte = Val(Label8.Caption)
    Label8.Caption = lngByte * 1024
    lngByte = Val(Label10.Caption)
    Label10.Caption = lngByte * 1024
    lngByte = Val(Label12.Caption)
    Label12.Caption = lngByte * 1024
    cmdByte.Caption = "Byte"
  End If
End Sub
Private Sub Form_Load()
  Dim udtMem As MEMORYSTATUS
  
  'CenterForm frmMemory
  
  GlobalMemoryStatus udtMem
  
  With udtMem
    ' Totaler physischer Speicher
    Label1.Caption = "Totaler physischer Speicher : "
    Label2.Caption = Format$(.dwTotalPhys, "@@@@@@@@@@@@")
    Label3.Caption = "Davon noch frei : "
    Label4.Caption = Format$(.dwAvailPhys, "@@@@@@@@@@@@")
  
    ' Speicher der gepagten Dateien
    Label5.Caption = "Bytes in gepageten Dateien :  "
    Label6.Caption = Format$(.dwTotalPageFile, "@@@@@@@@@@@@")
    Label7.Caption = "Davon noch frei : "
    Label8.Caption = Format$(.dwAvailPageFile, "@@@@@@@@@@@@")
  
    ' Totaler virtueller Speicher
    Label9.Caption = "Totaler virtueller Speicher: "
    Label10.Caption = Format$(.dwTotalVirtual, "@@@@@@@@@@@@")
    Label11.Caption = "Davon noch frei : "
    Label12.Caption = Format$(.dwAvailVirtual, "@@@@@@@@@@@@")
  End With
  
End Sub
