VERSION 5.00
Begin VB.Form frmPipeDos 
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Befehlszeileninterpreter"
   ClientHeight    =   6840
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   11775
   Icon            =   "PipeDOS.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6840
   ScaleWidth      =   11775
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox cboCommand 
      BackColor       =   &H00000000&
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00E0E0E0&
      Height          =   360
      Left            =   0
      TabIndex        =   1
      Text            =   "Befehlseingabe hier"
      Top             =   6480
      Width           =   10575
   End
   Begin VB.TextBox txtOutput 
      Appearance      =   0  '2D
      BackColor       =   &H00000000&
      BorderStyle     =   0  'Kein
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00E0E0E0&
      Height          =   6255
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   3
      Top             =   0
      Width           =   11775
   End
   Begin VB.CheckBox cmdChDir 
      BackColor       =   &H00000000&
      Caption         =   "&ChDir"
      ForeColor       =   &H00FFFFFF&
      Height          =   510
      Left            =   10560
      Style           =   1  'Grafisch
      TabIndex        =   2
      Top             =   6330
      Width           =   1200
   End
   Begin VB.Label lblCurDir 
      AutoSize        =   -1  'True
      BackColor       =   &H00000000&
      Caption         =   "C:\>"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00E0E0E0&
      Height          =   240
      Left            =   0
      TabIndex        =   0
      Top             =   6240
      Width           =   420
   End
End
Attribute VB_Name = "frmPipeDos"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Const MAX_PATH = 260

' SHBrowseForFolder flags
Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_EDITBOX = &H10
Private Const BIF_VALIDATE = &H20
Private Const BIF_NEWDIALOGSTYLE = &H40
Private Const BIF_USENEWUI = (BIF_NEWDIALOGSTYLE Or BIF_EDITBOX)

Private Type BROWSEINFO
  hwndOwner As Long
  pidlRoot As Long
  pszDisplayName As String
  lpszTitle As String
  ulFlags As Long
  lpfn As Long
  lParam As Long
  iImage As Long
End Type

Private Declare Function SHBrowseForFolder Lib "shell32" Alias "SHBrowseForFolderA" ( _
  lpbi As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" Alias "SHGetPathFromIDListA" ( _
  ByVal pidl As Long, _
  ByVal pszPath As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32" ( _
  pv As Any)
Private Declare Function SetCurrentDirectory Lib "kernel32" Alias "SetCurrentDirectoryA" ( _
  ByVal lpPathName As String) As Long
Private Declare Function GetVersion Lib "kernel32" () As Long
Private Sub cmdChDir_Click()
  Dim bi As BROWSEINFO
  Dim pidl As Long
  
  If cmdChDir.Value = vbChecked Then
    cmdChDir.Value = vbUnchecked
    With bi
      .hwndOwner = Me.hwnd
      .lpszTitle = "Whle ein neues Verzeichnis aus."
      .pszDisplayName = String$(MAX_PATH, 0)
      .ulFlags = BIF_RETURNONLYFSDIRS Or BIF_DONTGOBELOWDOMAIN Or _
                 BIF_VALIDATE Or BIF_USENEWUI
    End With
    ' zeigt das "Ordner suchen"-Fenster zur Auswahl eines Verzeichnisses an
    pidl = SHBrowseForFolder(bi)
    If pidl Then
      If SHGetPathFromIDList(pidl, bi.pszDisplayName) Then
        CD Left$(bi.pszDisplayName, InStr(bi.pszDisplayName, vbNullChar) - 1)
      End If
      CoTaskMemFree ByVal pidl
    End If
    cboCommand.SetFocus
  End If
End Sub
Private Sub Form_Load()
  CD Left$(frmDosShell.Laufwerk1.Drive, 2) & "\"
End Sub
Private Sub cboCommand_KeyPress(KeyAscii As Integer)
  Dim sCmd As String
  
  If KeyAscii = 13 Then ' Return wurde gedrckt
    ' Der eingegebene Befehl wird an die mit %COMSPEC% ermittelte Command bergeben und ausgefhrt
    ' Das ermglicht die Eingabe von DOS-Befehlen wie DIR und TYPE.
    If LCase(cboCommand.Text) = "exit" Then
      Unload frmPipeDos
    Else
      sCmd = Environ$("COMSPEC") & " /c " & cboCommand.Text
      ' Fr Windows 9x wird eine Zwischenlsung benutzt (RedirStub.exe)
      ' als Win32 Application, da dort die Command.com noch als
      ' 16-bit Programm luft. See KB article Q150956.
      If IsWin9x Then sCmd = "RedirStub " & sCmd
      txtOutput.Text = GetCommandOutput(sCmd, True, True)
      txtOutput.SelStart = Len(txtOutput.Text)                ' scrollt die Textbox zur letzten Zeile
      cboCommand.AddItem cboCommand.Text, 0    ' trgt die letzte Eingabe in die Combobox
      cboCommand.Text = ""
    End If
  End If
End Sub
' Setzt das aktuelle Verzeichnis und aktualisiert den Dos-Prompt
Private Sub CD(sPath As String)
  If SetCurrentDirectory(sPath) Then lblCurDir.Caption = sPath & ">"
End Sub
' Gibt True zurck bei Windows 9x, bei Windows NT/2000 = False
Private Function IsWin9x() As Boolean
  IsWin9x = CBool(GetVersion() And &H80000000)
End Function
